package com.xunmei.system.api.factory;

import com.xunmei.common.core.domain.R;
import com.xunmei.system.api.RemoteUserService;
import com.xunmei.system.api.domain.SysUser;
import com.xunmei.system.api.model.LoginUser;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

/**
 * 用户服务降级处理
 *
 * @author xunmei
 */
@Component
public class RemoteUserFallbackFactory implements FallbackFactory<RemoteUserService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteUserService create(Throwable throwable)
    {
        log.error("用户服务调用失败:{}", throwable.getMessage());
        return new RemoteUserService()
        {
            @Override
            public R<LoginUser> getUserInfo(String username, String source)
            {
                return R.fail("获取用户失败:" + throwable.getMessage());
            }

            @Override
            public SysUser getUserById(Long id, String source) {
                return null;
            }

            @Override
            public R<List<SysUser>> getAllSyncUser(SysUser request, String source) {
                return null;
            }

            @Override
            public R<Boolean> batchSaveSyncUser(List<SysUser> userList, String source) {
                return null;
            }

            @Override
            public R<Boolean> userLoginInfo(Long id, Date loginTime, String loginIp, String source) {
                return null;
            }

        };
    }
}
